searchData={"items":[{"type":"task","title":"mix compile.unifex","doc":"Generates native boilerplate code for all the `.spec.exs` files found in `c_src` dir","ref":"Mix.Tasks.Compile.Unifex.html"},{"type":"module","title":"Unifex","doc":"Implementation of `Bundlex.Preprocessor`.\n\nWhen added to a native configuration in `Bundlex.Project`, equips the native with\nthe Unifex native dependency and generated sources.","ref":"Unifex.html"},{"type":"module","title":"Unifex.CNode","doc":"Wraps Bundlex.CNode functionalities to support Unifex-specific CNode behaviours","ref":"Unifex.CNode.html"},{"type":"function","title":"Unifex.CNode.call/4","doc":"Makes a synchronous call to CNode and waits for its reply.\n\nIf the response doesn't come in within `timeout`, error is raised.\nMessages are exchanged directly (without interacting with CNode's associated\nserver).","ref":"Unifex.CNode.html#call/4"},{"type":"function","title":"Unifex.CNode.monitor/1","doc":"Starts monitoring CNode from the calling process.","ref":"Unifex.CNode.html#monitor/1"},{"type":"macro","title":"Unifex.CNode.start/1","doc":"Works the same way as `start_link/1`, but does not link to CNode's associated\nserver.","ref":"Unifex.CNode.html#start/1"},{"type":"function","title":"Unifex.CNode.start/2","doc":"Works the same way as `start_link/2`, but does not link to CNode's associated\nserver.","ref":"Unifex.CNode.html#start/2"},{"type":"macro","title":"Unifex.CNode.start_link/1","doc":"Spawns and connects to CNode `cnode_name`.\n\nFor details, see `Bundlex.CNode.start_link/2`.","ref":"Unifex.CNode.html#start_link/1"},{"type":"function","title":"Unifex.CNode.start_link/2","doc":"Spawns and connects to CNode `cnode_name` from application `app`.\n\nFor details, see `Bundlex.CNode.start_link/2`.","ref":"Unifex.CNode.html#start_link/2"},{"type":"function","title":"Unifex.CNode.stop/1","doc":"Disconnects from CNode.","ref":"Unifex.CNode.html#stop/1"},{"type":"type","title":"Unifex.CNode.on_start_t/0","doc":"","ref":"Unifex.CNode.html#t:on_start_t/0"},{"type":"type","title":"Unifex.CNode.t/0","doc":"","ref":"Unifex.CNode.html#t:t/0"},{"type":"behaviour","title":"Unifex.CodeGenerator","doc":"Behaviour for code generation.","ref":"Unifex.CodeGenerator.html"},{"type":"function","title":"Unifex.CodeGenerator.bundlex_interface/1","doc":"","ref":"Unifex.CodeGenerator.html#bundlex_interface/1"},{"type":"function","title":"Unifex.CodeGenerator.generate_code/1","doc":"Generates boilerplate code using generator implementation from `Unifex.CodeGenerators`.","ref":"Unifex.CodeGenerator.html#generate_code/1"},{"type":"callback","title":"Unifex.CodeGenerator.generate_header/1","doc":"","ref":"Unifex.CodeGenerator.html#c:generate_header/1"},{"type":"callback","title":"Unifex.CodeGenerator.generate_source/1","doc":"","ref":"Unifex.CodeGenerator.html#c:generate_source/1"},{"type":"callback","title":"Unifex.CodeGenerator.identification_constant/0","doc":"","ref":"Unifex.CodeGenerator.html#c:identification_constant/0"},{"type":"function","title":"Unifex.CodeGenerator.interface_generator/1","doc":"","ref":"Unifex.CodeGenerator.html#interface_generator/1"},{"type":"callback","title":"Unifex.CodeGenerator.interface_io_name/0","doc":"","ref":"Unifex.CodeGenerator.html#c:interface_io_name/0"},{"type":"type","title":"Unifex.CodeGenerator.code_t/0","doc":"","ref":"Unifex.CodeGenerator.html#t:code_t/0"},{"type":"type","title":"Unifex.CodeGenerator.generated_code_t/0","doc":"","ref":"Unifex.CodeGenerator.html#t:generated_code_t/0"},{"type":"type","title":"Unifex.CodeGenerator.t/0","doc":"","ref":"Unifex.CodeGenerator.html#t:t/0"},{"type":"behaviour","title":"Unifex.CodeGenerator.BaseType","doc":"Behaviour and abstraction over type-specific code generation.\n\nWhen invoking callbacks for type `:type` and interface `Interface` it searches for\na module that implements given callback in the following order:\n- `Unifex.CodeGenerator.BaseTypes.Type.Interface`\n- `Unifex.CodeGenerator.BaseTypes.Type`\n- `Unifex.CodeGenerator.BaseTypes.Default.Interface`","ref":"Unifex.CodeGenerator.BaseType.html"},{"type":"function","title":"Unifex.CodeGenerator.BaseType.generate_arg_name/4","doc":"","ref":"Unifex.CodeGenerator.BaseType.html#generate_arg_name/4"},{"type":"callback","title":"Unifex.CodeGenerator.BaseType.generate_arg_parse/3","doc":"Generates function call parsing UNIFEX_TERM `argument` into the native variable with name `variable`. Function should\nreturn boolean value.","ref":"Unifex.CodeGenerator.BaseType.html#c:generate_arg_parse/3"},{"type":"function","title":"Unifex.CodeGenerator.BaseType.generate_arg_parse/6","doc":"Generates parsing of UNIFEX_TERM `argument` into the native variable","ref":"Unifex.CodeGenerator.BaseType.html#generate_arg_parse/6"},{"type":"callback","title":"Unifex.CodeGenerator.BaseType.generate_arg_serialize/2","doc":"Provides a way to convert native variable `name` into `UNIFEX_TERM`","ref":"Unifex.CodeGenerator.BaseType.html#c:generate_arg_serialize/2"},{"type":"function","title":"Unifex.CodeGenerator.BaseType.generate_arg_serialize/4","doc":"Provides a way to convert native variable `name` into `UNIFEX_TERM`\n\nTries to get value from type-specific module, uses `enif_make_#{type}` as fallback value.","ref":"Unifex.CodeGenerator.BaseType.html#generate_arg_serialize/4"},{"type":"function","title":"Unifex.CodeGenerator.BaseType.generate_declaration/5","doc":"Generates a declaration of parameter (to be placed in function header) based on `c:generate_native_type/1` and\nprovided `name`.\n\nUses `type` as fallback for `c:generate_native_type/1`\n\nWhen mode is set to :const_unless_ptr_on_ptr, function will choose to behave like it would be set to :default or :const,\ndepending on value returned by `ptr_level(type, code_generator, ctx)`.\nThis mode can be used in places, when in general, you want to have declaration of variable with const type, but using :const\nmode would generate code, that would require explicit cast to avoid generating warnings during compilation - e.g. in C,\npassing argument of type `char **` to function, that expects argument of type `char const * const *` without any explicit cast,\nwill generate such a warning","ref":"Unifex.CodeGenerator.BaseType.html#generate_declaration/5"},{"type":"callback","title":"Unifex.CodeGenerator.BaseType.generate_destruction/2","doc":"Generates a destruction of variable content. Should be paired with `c:generate_initialization/2`","ref":"Unifex.CodeGenerator.BaseType.html#c:generate_destruction/2"},{"type":"function","title":"Unifex.CodeGenerator.BaseType.generate_destruction/4","doc":"Generates an destrucition of variable content. Should be paired with `generate_initialization/1`\n\nReturns an empty string if the type does not provide destructor","ref":"Unifex.CodeGenerator.BaseType.html#generate_destruction/4"},{"type":"callback","title":"Unifex.CodeGenerator.BaseType.generate_initialization/2","doc":"Generates an initialization of variable content. Should be paired with `c:generate_destruction/2`","ref":"Unifex.CodeGenerator.BaseType.html#c:generate_initialization/2"},{"type":"function","title":"Unifex.CodeGenerator.BaseType.generate_initialization/4","doc":"Generates an initialization of variable content. Should be paired with `generate_destruction/1`\n\nReturns an empty string if the type does not provide initialization","ref":"Unifex.CodeGenerator.BaseType.html#generate_initialization/4"},{"type":"callback","title":"Unifex.CodeGenerator.BaseType.generate_native_type/1","doc":"Generates a native counterpart for the type.","ref":"Unifex.CodeGenerator.BaseType.html#c:generate_native_type/1"},{"type":"function","title":"Unifex.CodeGenerator.BaseType.generate_native_type/4","doc":"","ref":"Unifex.CodeGenerator.BaseType.html#generate_native_type/4"},{"type":"callback","title":"Unifex.CodeGenerator.BaseType.ptr_level/1","doc":"Returns level of pointer nesting of native type.","ref":"Unifex.CodeGenerator.BaseType.html#c:ptr_level/1"},{"type":"function","title":"Unifex.CodeGenerator.BaseType.ptr_level/3","doc":"","ref":"Unifex.CodeGenerator.BaseType.html#ptr_level/3"},{"type":"type","title":"Unifex.CodeGenerator.BaseType.arg_parse_ctx_t/0","doc":"","ref":"Unifex.CodeGenerator.BaseType.html#t:arg_parse_ctx_t/0"},{"type":"type","title":"Unifex.CodeGenerator.BaseType.t/0","doc":"","ref":"Unifex.CodeGenerator.BaseType.html#t:t/0"},{"type":"module","title":"Unifex.CodeGenerator.Utils","doc":"Utilities for code generation.","ref":"Unifex.CodeGenerator.Utils.html"},{"type":"function","title":"Unifex.CodeGenerator.Utils.generate_enums_definitions/3","doc":"","ref":"Unifex.CodeGenerator.Utils.html#generate_enums_definitions/3"},{"type":"function","title":"Unifex.CodeGenerator.Utils.generate_functions/3","doc":"","ref":"Unifex.CodeGenerator.Utils.html#generate_functions/3"},{"type":"function","title":"Unifex.CodeGenerator.Utils.generate_functions_declarations/3","doc":"","ref":"Unifex.CodeGenerator.Utils.html#generate_functions_declarations/3"},{"type":"function","title":"Unifex.CodeGenerator.Utils.generate_maybe_unused_args_statements/1","doc":"","ref":"Unifex.CodeGenerator.Utils.html#generate_maybe_unused_args_statements/1"},{"type":"function","title":"Unifex.CodeGenerator.Utils.generate_serialization/2","doc":"Traverses Elixir specification AST and creates C data types serialization\nwith `serializers`.","ref":"Unifex.CodeGenerator.Utils.html#generate_serialization/2"},{"type":"function","title":"Unifex.CodeGenerator.Utils.generate_structs_definitions/3","doc":"","ref":"Unifex.CodeGenerator.Utils.html#generate_structs_definitions/3"},{"type":"function","title":"Unifex.CodeGenerator.Utils.sanitize_var_name/1","doc":"Replaces special characters such as: `.`, `->` and array brackets e.g. `var_name[i]`\nwith underscores.\n\nIn case of arrays `var_name[i]` results in `var_name_i`.","ref":"Unifex.CodeGenerator.Utils.html#sanitize_var_name/1"},{"type":"function","title":"Unifex.CodeGenerator.Utils.sigil_g/2","doc":"Sigil used for templating generated code.","ref":"Unifex.CodeGenerator.Utils.html#sigil_g/2"},{"type":"module","title":"Unifex.Loader","doc":"This module allows to generate definitions for native functions described in Unifex specs.\n\nTo achieve that simply use this module:\n\n    use Unifex.Loader","ref":"Unifex.Loader.html"},{"type":"module","title":"Unifex.Specs","doc":"Module that handles parsing Unifex specs for native boilerplate code generation.\n\nFor information on how to create such specs, see `Unifex.Specs.DSL` module.","ref":"Unifex.Specs.html"},{"type":"function","title":"Unifex.Specs.parse/2","doc":"Parses Unifex specs of native functions.","ref":"Unifex.Specs.html#parse/2"},{"type":"type","title":"Unifex.Specs.enum_t/0","doc":"","ref":"Unifex.Specs.html#t:enum_t/0"},{"type":"type","title":"Unifex.Specs.interface_t/0","doc":"Name of interface generated for the native library.\nMust be a suffix of code generator module in `Unifex.CodeGenerators` namespace.\n\nUnifex has built-in generators for `NIF` and `CNode` interfaces.","ref":"Unifex.Specs.html#t:interface_t/0"},{"type":"type","title":"Unifex.Specs.native_name_t/0","doc":"","ref":"Unifex.Specs.html#t:native_name_t/0"},{"type":"type","title":"Unifex.Specs.struct_t/0","doc":"","ref":"Unifex.Specs.html#t:struct_t/0"},{"type":"type","title":"Unifex.Specs.t/0","doc":"","ref":"Unifex.Specs.html#t:t/0"},{"type":"module","title":"Unifex.Specs.DSL","doc":"Module exporting macros that can be used to define Unifex specs.\n\nExample of such specs is provided below:\n\n    module Membrane.Element.Mad.Decoder.Native\n\n    type position :: :manager | :developer | :intern | :product_owner\n\n    type personal_data :: %PersonalData{\n      age: int,\n      experience: int,\n      name: string\n    }\n\n    spec get_salary(person :: personal_data, person_position :: position) ::\n           {:ok :: label, salary :: int}\n           {:error :: label, :unemployed :: label}\n\n    spec create() :: {:ok :: label, state}\n\n    spec decode_frame(payload, offset :: int, state) ::\n           {:ok :: label, {payload, bytes_used :: long, sample_rate :: long, channels :: int}}\n           | {:error :: label, :buflen :: label}\n           | {:error :: label, :malformed :: label}\n           | {:error :: label, {:recoverable :: label, bytes_to_skip :: int}}\n\n    dirty :cpu, decode_frame: 3\n\n    sends {:example_msg :: label, number :: int}\n\nAccording to this specification, module `Membrane.Element.Mad.Decoder.Native` should contain 2 functions: `create/0`\nand `decode_frame/3` (which is a cpu-bound dirty NIF). The module should use `Unifex.Loader` to provide access to\nthese functions. What is more, messages of the form `{:example_msg, integer}` can be sent from the native code to\nerlang processes.\n\nFollowing types definitions will be generated and will be available from native code\n\n    #ifdef __cplusplus\n    enum Position { MANAGER, DEVELOPER, INTERN, PRODUCT_OWNER };\n    #else\n    enum Position_t { MANAGER, DEVELOPER, INTERN, PRODUCT_OWNER };\n    typedef enum Position_t Position;\n    #endif\n\n    #ifdef __cplusplus\n    struct personal_data {\n      int age;\n      int experience;\n      char *name;\n    };\n    #else\n    struct personal_data_t {\n      int age;\n      int experience;\n      char *name;\n    };\n    typedef struct personal_data_t personal_data;\n    #endif\n\nThe generated boilerplate would require implementation of the following functions:\n\n    UNIFEX_TERM get_salary(UnifexEnv *env, personal_data person, Position person_position);\n    UNIFEX_TERM create(UnifexEnv* env);\n    UNIFEX_TERM decode_frame(UnifexEnv* env, UnifexPayload * payload, int offset, State* state);\n\nAlso the following functions that should be called to return results will be generated:\n\n    UNIFEX_TERM get_salary_result_ok(UnifexEnv *env, int salary);\n    UNIFEX_TERM get_salary_result_error_unemployed(UnifexEnv *env);\n    UNIFEX_TERM create_result_ok(UnifexEnv* env, State* state);\n    UNIFEX_TERM decode_frame_result_ok(UnifexEnv* env, UnifexPayload * payload,\n                                       long bytes_used, long sample_rate, int channels);\n    UNIFEX_TERM decode_frame_result_error_buflen(UnifexEnv* env);\n    UNIFEX_TERM decode_frame_result_error_malformed(UnifexEnv* env);\n    UNIFEX_TERM decode_frame_result_error_recoverable(UnifexEnv* env, int bytes_to_skip);\n\nSee docs for appropriate macros for more details.","ref":"Unifex.Specs.DSL.html"},{"type":"macro","title":"Unifex.Specs.DSL.@/1","doc":"Defines native function documentation.\n  Documentation will be visible in the generated docs.\n\n  The documentation should be in the form of\n\n      @doc \"\"\"\n      Documentation...\n      \"\"\"\n      spec function_name...","ref":"Unifex.Specs.DSL.html#@/1"},{"type":"macro","title":"Unifex.Specs.DSL.callback/2","doc":"Defines names of callbacks invoked on specified hook.\n\nThe available hooks are:\n\n* `:load` - invoked when the library is loaded. Callback must have the following typing:\n\n  `int on_load(UnifexEnv *env, void ** priv_data)`\n\n  The callback receives an `env` and a pointer to private data that is initialized\n  with NULL and can be set to whatever should be passed to other callbacks.\n  If callback returns anything else than 0, the library fails to load.\n\n* `:upgrade` - called when the library is loaded while there is old code for this module\n  with a native library loaded. Compared to `:load`, it also receives `old_priv_data`:\n\n  `int on_upgrade(UnifexEnv* env, void** priv_data, void** old_priv_data)`\n\n  Both old and new private data can be modified\n  If this callback is not defined, the module code cannot be hot-swapped. Non-zero return\n  value also prevents code upgrade.\n\n* `:unload` - called when the code for module is unloaded. It has the following declaration:\n\n  `void on_unload(UnifexEnv *env, void * priv_data)`","ref":"Unifex.Specs.DSL.html#callback/2"},{"type":"macro","title":"Unifex.Specs.DSL.dirty/2","doc":"Macro used for marking functions as dirty, i.e. performing long cpu-bound or\nio-bound operations.\n\nThe macro should be used the following way:\n\n    dirty type, function1: function1_arity, ...\n\nwhen type is one of:\n- `:cpu` - marks function as CPU-bound (maps to the `ERL_NIF_DIRTY_JOB_CPU_BOUND` erlang flag)\n- `:io` - marks function as IO-bound (maps to the `ERL_NIF_DIRTY_JOB_IO_BOUND` erlang flag)","ref":"Unifex.Specs.DSL.html#dirty/2"},{"type":"macro","title":"Unifex.Specs.DSL.interface/1","doc":"Specifies interface, for example NIF or CNode.\n\nIt should be a module name (or list of module names) that will be prepended\nwith `Unifex.CodeGenerators`. If no interface is specified, it is automatically\ndetected basing on `Bundlex.Project` specification.","ref":"Unifex.Specs.DSL.html#interface/1"},{"type":"macro","title":"Unifex.Specs.DSL.module/1","doc":"Defines module that exports native functions to Elixir world.\n\nThe module needs to be defined manually, but it can `use` `Unifex.Loader` to\nhave functions declared with `spec/1` automatically defined.","ref":"Unifex.Specs.DSL.html#module/1"},{"type":"macro","title":"Unifex.Specs.DSL.sends/1","doc":"Defines terms that can be sent from the native code to elixir processes.\n\nCreates native function that can be invoked to send specified data. Name of the\nfunction starts with `send_` and is constructed from `label`s.","ref":"Unifex.Specs.DSL.html#sends/1"},{"type":"macro","title":"Unifex.Specs.DSL.spec/1","doc":"Defines native function specification.\n\nThe specification should be in the form of\n\n    spec function_name(parameter1 :: parameter1_type, some_type, parameter3 :: parameter3_type, ...) ::\n        {:label1 :: label, {result_value1 :: result_value1_type, some_type2, ...}}\n        | {:label2 :: label, other_result_value2 :: other_result_value2_type}","ref":"Unifex.Specs.DSL.html#spec/1"},{"type":"macro","title":"Parameters - Unifex.Specs.DSL.spec/1","doc":"Specs for parameters can either take the form of `parameter1 :: parameter1_type`\nwhich will generate parameter with name `parameter1` of type `parameter1_type`\nThe other form - just a name, like `some_type` - will generate parameter `some_type`\nof type `some_type`.\n\nCustom types can be added by creating modules `Unifex.CodeGenerator.BaseTypes.Type` that implement\n`Unifex.CodeGenerator.BaseType` behaviour. Then, they can by used in specs as `type`.\n\nEach generated function gets additional `UnifexEnv* env` as the first parameter implicitly.","ref":"Unifex.Specs.DSL.html#spec/1-parameters"},{"type":"macro","title":"Returned values - Unifex.Specs.DSL.spec/1","doc":"Specs for returned values contain a special type - `label`. An atom of type `label`\nwill be put literally in returned values by the special function generated for each\nspec. Names of the generated functions start with Elixir function name\n(e.g. `create`) followed by `_result_` part and then all the labels joined with `_`.","ref":"Unifex.Specs.DSL.html#spec/1-returned-values"},{"type":"macro","title":"Example - Unifex.Specs.DSL.spec/1","doc":"The example is provided in the moduledoc of this module.","ref":"Unifex.Specs.DSL.html#spec/1-example"},{"type":"macro","title":"Unifex.Specs.DSL.state_type/1","doc":"Defines the state type, required for using `Unifex.CodeGenerator.BaseTypes.State`.","ref":"Unifex.Specs.DSL.html#state_type/1"},{"type":"macro","title":"Unifex.Specs.DSL.type/1","doc":"Contains user custom type specification\n\nCurrently supported types are enums and structs\n\nThe struct specification should be in the form of\n\n    type my_struct :: %My.Struct{\n      field1: type1,\n      field2: type2,\n      ...\n    }\n\nThe enum specification should be in the form of\n\n    type my_enum :: :option_one | :option_two | :option_three | ...\n\nStruct or enums specified in such way can be used in like any other supported type, E.g.\n\n    spec my_function(in_enum :: my_enum) :: {:ok :: label, out_struct :: my_struct}\n\nElixir definition of %My.Struct{} should contain every field listed in specification and is not generated by Unifex","ref":"Unifex.Specs.DSL.html#type/1"},{"type":"module","title":"Unifex.CodeGenerators.CNode","doc":"Generates C node boilerplate based on `Unifex.Specs`.","ref":"Unifex.CodeGenerators.CNode.html"},{"type":"module","title":"Unifex.CodeGenerators.NIF","doc":"Generates NIF boilerplate based on `Unifex.Specs`.","ref":"Unifex.CodeGenerators.NIF.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Atom","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for atoms.\n\nAtoms in native code are represented by C-strings (`char *`)\n\nImplemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Atom.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Bool","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for boolean atoms.\n\nBooleans in native code are converted to int with value either 0 or 1.\n\nImplemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Bool.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Default","doc":"Default `Unifex.CodeGenerator.BaseType` implementation for all types.\n\nIf a callback is not implemented in a type-specific implementation,\nit defaults to this one.","ref":"Unifex.CodeGenerator.BaseTypes.Default.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Enum","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for C Enums.\n\nImplemented both for NIF and CNode.","ref":"Unifex.CodeGenerator.BaseTypes.Enum.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Float","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for floats.\n\nImplemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Float.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Int","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for integers.\n\nImplemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Int.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Int64","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for 64-bit integer.\n\nMaps `int64` Unifex type to an `int64_t` native type.\n\nImplemented only for NIF as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Int64.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.List","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for lists.\n\nThey are represented in the native code as arrays with sizes passed\nvia separate arguments.\n\nImplemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.List.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Payload","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for payloads.\n\nImplemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Payload.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Pid","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for Erlang PIDs.\n\nImplemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Pid.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.State","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for Unifex state.\n\nTo use it, specify the state type with `Unifex.Specs.DSL.state_type/1`.","ref":"Unifex.CodeGenerator.BaseTypes.State.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.String","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for strings.\n\nThey are represented by NULL-terminated char arrays.\n\nImplemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.String.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Struct","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for structs.\n\nElixir structs in native code are represented by C structs.\n\nImplemented both for NIF and CNode.","ref":"Unifex.CodeGenerator.BaseTypes.Struct.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Uint64","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for 64-bit unsigned integer.\n\nMaps `uint64` Unifex type to a `uint64_t` native type.\n\nImplemented only for NIF as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Uint64.html"},{"type":"module","title":"Unifex.CodeGenerator.BaseTypes.Unsigned","doc":"Module implementing `Unifex.CodeGenerator.BaseType` behaviour for unsigned int.\n\nImplemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Unsigned.html"},{"type":"extras","title":"Unifex","doc":"# Unifex\n\n[![Hex.pm](https://img.shields.io/hexpm/v/unifex.svg)](https://hex.pm/packages/unifex)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/unifex/)\n[![CircleCI](https://circleci.com/gh/membraneframework/unifex.svg?style=svg)](https://circleci.com/gh/membraneframework/unifex)\n\nUnifex is a tool for generating interfaces between native C code and Elixir, that:\n- provides intuitive and concise tools for defining native interfaces,\n- generates all the boilerplate for you,\n- provides useful abstractions over binaries and state,\n- makes native code independent from [erl_nif](https://erlang.org/doc/man/erl_nif.html) \n  or [ei](https://erlang.org/doc/man/ei.html) library, so the same code is usable either with NIFs or CNodes.\n\nAPI documentation is available at [HexDocs](https://hexdocs.pm/unifex/).\n\nUnifex uses [Bundlex](https://github.com/membraneframework/bundlex) to compile and load the native code. See there for supported platforms & details.\n\nThis tool is maintained by the [Membrane Framework](https://membraneframework.org/) team.","ref":"readme.html"},{"type":"extras","title":"Installation - Unifex","doc":"To install, you need to configure Mix project as follows:\n\n```elixir\ndefmodule MyApp.Mixfile do\n  use Mix.Project\n\n  def project do\n    [\n      app: :my_app,\n      compilers: [:unifex, :bundlex] ++ Mix.compilers, # add unifex and bundlex to compilers\n      ...,\n      deps: deps()\n   ]\n  end\n\n  defp deps() do\n    [\n      {:unifex, \"~>> 1.1.1\"}\n    ]\n  end\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Unifex","doc":"For detailed usage description see [Creating Unifex Natives](https://hexdocs.pm/unifex/creating_unifex_natives.html) guide.","ref":"readme.html#usage"},{"type":"extras","title":"Supported types - Unifex","doc":"For currently supported types see [Supported Types](https://hexdocs.pm/unifex/supported_types.html) section.","ref":"readme.html#supported-types"},{"type":"extras","title":"See also - Unifex","doc":"Unifex depends on the following libraries:\n- [Bundlex](https://github.com/membraneframework/bundlex)\n- [Shmex](https://github.com/membraneframework/shmex)","ref":"readme.html#see-also"},{"type":"extras","title":"Copyright and License - Unifex","doc":"Copyright 2018, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2018 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"},{"type":"extras","title":"Creating Unifex Natives","doc":"# Creating Unifex Natives","ref":"creating_unifex_natives.html"},{"type":"extras","title":"Introduction - Creating Unifex Natives","doc":"In this tutorial, you will learn how to use Unifex natives to write native code that can be compiled both as NIF and CNode.","ref":"creating_unifex_natives.html#introduction"},{"type":"extras","title":"Preparation - Creating Unifex Natives","doc":"In order to start working, you need to prepare a few things:\n\n1. First, you have to add unifex to your dependencies as well as unifex and bundlex compilers.\n   Please refer to [Installation](https://hexdocs.pm/unifex/readme.html#installation) section to see how to do it. \n2. After successful installation we should take a look at [Bundlex](https://github.com/membraneframework/bundlex).\n   Unifex uses Bundlex to compile the native code. \n   You can think of Bundlex as a tool that generates build scripts responsible for including proper libs compiling your native code and linking it with mentioned libs.\n   To make it work, create the `bundlex.exs` file in the project's root directory with the following content:\n```elixir\ndefmodule Example.BundlexProject do\n  use Bundlex.Project\n\n  def project() do\n    [\n      natives: natives(Bundlex.platform())\n    ]\n  end\n\n  def natives(_platform) do\n    [\n      example: [\n        sources: [\"example.c\"],\n        interface: [:nif, :cnode],\n        preprocessor: Unifex\n      ]\n    ]\n  end\nend\n```\n\n   This defines a native called `example`, that should be implemented in the `example.c` file. We'll also need `example.spec.exs` file, that Unifex needs to generate boilerplate code for compiling the native as NIF and CNode. Both files should be located in the `c_src/example` folder. Setting `Unifex` as a preprocessor lets it extend the configuration with the generated code.\n   More details on how to use bundlex can be found in its [documentation](https://hexdocs.pm/bundlex).","ref":"creating_unifex_natives.html#preparation"},{"type":"extras","title":"Native code - Creating Unifex Natives","doc":"Let's start by creating a `c_src/example` directory, and the files that will be needed:\n\n```bash\nmkdir -p c_src/example\ncd c_src/example\ntouch example.c\ntouch example.h\ntouch example.spec.exs\n```\n\nHere are the contents of `example.spec.exs`:\n\n```elixir\nmodule Example\n\ninterface [NIF, CNode]\n\nspec foo(num :: int) :: {:ok :: label, answer :: int}\n```\n\nNote that here we also specified an interface or even interfaces!\nIt is not necessary because if we didn't do it Unifex would take it from `bundlex.exs`.\nHowever, this is a good practice that makes code clearer and is also a little faster than fetching info from `bundlex.exs.` \n\nNext step is to implement our `example.h`.\nSince our example is very simple our `example.h` will be very simple too:\n```c\n#include \"_generated/example.h\"\n```\n\nIt just includes generated header file that contains some function definitions we use in our `example.c`. The header will be generated by Unifex based on the `example.spec.exs` file.\n\nNow, let's provide required implementation in `example.c`:\n\n```c\n#include \"example.h\"\n\nUNIFEX_TERM foo(UnifexEnv* env, int num) {\n  return foo_result_ok(env, num);\n}\n```\nThe provided `foo` implementation returns the passed argument, by using `foo_result_ok`. For every tuple, that might be returned from our Unifex function, there will be generated implementation of result function named `[orginal_function_name]_result_[label]`, where `label` is an atom with type `label` in returned tuple. The type of the first argument of this function will be `UnifexEnv*`, number and types of the rest of the arguments will depend on the number and types of rest of elements in the returned tuple\n\nAt this moment the project should successfully compile. \nRun `mix deps.get && mix compile` to make sure everything is fine.\nIn `c_src/_generated/` directory there should appear files both for usage as NIF and CNode.\n\n#","ref":"creating_unifex_natives.html#native-code"},{"type":"extras","title":"Types - Creating Unifex Natives","doc":"With Unifex, you can use some of built-in Elixir types (see more in [documentation](https://hexdocs.pm/unifex/supported_types.html)), as well as your custom types. Currently, we support defining enums and structs. If you want to add structs or enums to the API of your native functions, you have to define them in the `*.spec.exs` file. There is an example of this:\n\n```elixir\ntype my_enum :: :option_one | :option_two | :option_three | :option_four | :option_five\n\ntype my_struct :: %My.Struct{\n  id: int,\n  data: [int],\n  name: string\n}\n\ntype nested_struct :: %Nested.Struct{\n  inner_struct: my_struct,\n  id: int\n}\n```\n\nThen, we will generate two versions of native declarations of our custom types, each for `C` and `C++`. An example of version for `C` is posted below\n\n```cpp\nenum MyEnum_t {\n  MY_ENUM_OPTION_ONE,\n  MY_ENUM_OPTION_TWO,\n  MY_ENUM_OPTION_THREE,\n  MY_ENUM_OPTION_FOUR,\n  MY_ENUM_OPTION_FIVE\n};\ntypedef enum MyEnum_t MyEnum;\n\nstruct my_struct_t {\n  int id;\n  int *data;\n  unsigned int data_length;\n  char *name;\n};\ntypedef struct my_struct_t my_struct;\n\nstruct nested_struct_t {\n  my_struct inner_struct;\n  int id;\n};\ntypedef struct nested_struct_t nested_struct;\n```\n\nThe name of enum will be translated to PascalCase, specific options will be prefixed with enum name and translated to MACRO_CASE.\n\nRemember, that in `C` it is forbidden to make a cyclic chain of containment in the way, that it was made above.\n\nNow, you can use your custom types, like basic ones, e.g.\n\n```elixir\nspec example_function(in_enum :: my_enum, in_struct :: nested_struct) :: {:ok :: label, out_struct :: my_struct} | {:error :: label, reason :: atom}\n```\n\n```cpp\nUNIFEX_TERM example_function(UnifexEnv *env, MyEnum in_enum, nested_struct in_struct) {\n  if (in_enum == MY_ENUM_OPTION_ONE) {\n    return example_function_result_error(env, \"failed\");\n  }\n  return example_function_result_ok(env, in_struct.inner_struct);\n}\n```\n\nIf you want to pass enum to Unifex function on Elixir side, you have to use atom (this same, that was used in enum definition in `*.spec.exs` file). By analogy, the result of Unifex function returning enum will be visible as an atom on the Elixir side. What is important, declaration of a specific struct in `*.spec.exs` will not automatically make it available in your Elixir code - you are responsible for providing struct module on your own.","ref":"creating_unifex_natives.html#types"},{"type":"extras","title":"Running code - Creating Unifex Natives","doc":"#","ref":"creating_unifex_natives.html#running-code"},{"type":"extras","title":"NIF - Creating Unifex Natives","doc":"All you have to do in order to access natively implemented functions is to create a module with the name as defined \nin `example.spec.exs` and to use `Unifex.Loader` there:\n\n```elixir\ndefmodule Example do\n  use Unifex.Loader\nend\n```\n\nAnd that's it! You can now run `iex -S mix` and check it out yourself:\n\n```elixir\niex(1)> Example.foo(10)\n{:ok, 10}\n```\n\n#","ref":"creating_unifex_natives.html#nif"},{"type":"extras","title":"CNode - Creating Unifex Natives","doc":"In case of `CNodes`, module with `Unifex.Loader` is unnecessary. We would just do:\n```elixir\niex(2)> require Unifex.CNode\nUnifex.CNode\niex(3)> {:ok, cnode} = Unifex.CNode.start_link(:example)\n{:ok,\n %Unifex.CNode{\n   bundlex_cnode: %Bundlex.CNode{\n     node: :\"bundlex_cnode_0_4eb957f2-fd47-47c2-b816-6e9c580e658a@michal\",\n     server: #PID<0.259.0>\n   },\n   node: :\"bundlex_cnode_0_4eb957f2-fd47-47c2-b816-6e9c580e658a@michal\",\n   server: #PID<0.259.0>\n }}\niex(bundlex_app_4eb957f2-...)4> Unifex.CNode.call(cnode, :foo, [10])\n{:ok, 10}\n```","ref":"creating_unifex_natives.html#cnode"},{"type":"extras","title":"More examples - Creating Unifex Natives","doc":"You can find more complete projects [here](https://github.com/membraneframework/unifex/tree/master/test_projects).\nAlso check out how we use Unifex in our [repositories](https://github.com/membraneframework) \nand please refer to `Unifex.Specs.DSL` module's documentation to see how to create more advanced `*.spec.exs` files.","ref":"creating_unifex_natives.html#more-examples"},{"type":"extras","title":"Creating Unifex NIF","doc":"# Creating Unifex NIF\n\nThis page was moved, see [Creating Unifex natives](https://hexdocs.pm/unifex/creating_unifex_natives.html)","ref":"creating_unifex_nif.html"},{"type":"extras","title":"Supported types","doc":"# Supported types\n\nUnifex supports generating code both for usage with NIF's and CNode's. \nNevertheless, some types can be not implemented yet.\nBelow we present which types you can use at this moment. \nYou can also refer to [#42](https://github.com/membraneframework/unifex/issues/42) to see \nstate of work on remaining types.","ref":"supported_types.html"},{"type":"extras","title":"Supported types - Supported types","doc":"| Elixir type | Native type                     | in NIF as a function parameter | in NIF as a return type | in CNode as a function parameter | in CNode as a return type  |\n| ---------   | :-----------------------------: | :-------------------------: | :------------------: | :---------------------------: | :---------------------: |\n| `atom`      | `char *`                        | ✅                          | ✅                    | ✅                            | ✅                      |\n| `bool`      | `int`                           | ✅                          | ✅                    | ✅                            | ✅                      |\n| `unsigned`  | `unsigned int`                  | ✅                          | ✅                    | ✅                            | ✅                      |\n| `uint64`    | `uint64_t`                      | ✅                          | ✅                    | ❌                            | ❌                      |\n| `int`       | `int`                           | ✅                          | ✅                    | ✅                            | ✅                      |\n| `int64`     | `int64_t`                       | ✅                          | ✅                    | ❌                            | ❌                      |\n| `float`     | `double`                        | ✅                          | ✅                    | ✅                            | ✅                      |\n| `payload`   | `UnifexPayload`                 | ✅                          | ✅                    | ✅                            | ✅                      |\n| `pid`       | `UnifexPid`                     | ✅                          | ✅                    | ✅                            | ✅                      |\n| `string`    | `char *`                        | ✅                          | ✅                    | ✅                            | ✅                      |\n| `[type]`    | `native_type *`, `unsigned int` | ✅                          | ✅                    | ✅                            | ✅                      |","ref":"supported_types.html#supported-types"}],"content_type":"text/markdown"}